diff --git a/compiler/typecheck/TcUnify.lhs b/compiler/typecheck/TcUnify.lhs
index b226e4b..4ace630 100644
--- a/compiler/typecheck/TcUnify.lhs
+++ b/compiler/typecheck/TcUnify.lhs
@@ -6,12 +6,6 @@
 Type subsumption and unification
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcUnify (
   -- Full-blown subsumption
@@ -99,8 +93,8 @@ thing_inside, and returns a wrapper to coerce between the two types
 
 It's used wherever a language construct must have a functional type,
 namely:
-	A lambda expression
-	A function definition
+        A lambda expression
+        A function definition
      An operator section
 
 This is not (currently) where deep skolemisation occurs;
@@ -109,9 +103,9 @@ expected type, because it expects that to have been done already
 
 
 \begin{code}
-matchExpectedFunTys :: SDoc 	-- See Note [Herald for matchExpectedFunTys]
-            	    -> Arity
-            	    -> TcRhoType 
+matchExpectedFunTys :: SDoc     -- See Note [Herald for matchExpectedFunTys]
+                    -> Arity
+                    -> TcRhoType 
                     -> TcM (TcCoercion, [TcSigmaType], TcRhoType)
 
 -- If    matchExpectFunTys n ty = (co, [t1,..,tn], ty_r)
@@ -120,7 +114,7 @@ matchExpectedFunTys :: SDoc 	-- See Note [Herald for matchExpectedFunTys]
 -- Does not allocate unnecessary meta variables: if the input already is 
 -- a function, we just take it apart.  Not only is this efficient, 
 -- it's important for higher rank: the argument might be of form
---		(forall a. ty) -> other
+--              (forall a. ty) -> other
 -- If allocated (fresh-meta-var1 -> fresh-meta-var2) and unified, we'd
 -- hide the forall inside a meta-variable
 
@@ -144,9 +138,9 @@ matchExpectedFunTys herald arity orig_ty
     go n_req ty@(TyVarTy tv)
       | ASSERT( isTcTyVar tv) isMetaTyVar tv
       = do { cts <- readMetaTyVar tv
-	   ; case cts of
-	       Indirect ty' -> go n_req ty'
-	       Flexi        -> defer n_req ty }
+           ; case cts of
+               Indirect ty' -> go n_req ty'
+               Flexi        -> defer n_req ty }
 
        -- In all other cases we bale out into ordinary unification
        -- However unlike the meta-tyvar case, we are sure that the
@@ -173,9 +167,9 @@ matchExpectedFunTys herald arity orig_ty
 
     mk_msg ty n_args
       = herald <+> speakNOf arity (ptext (sLit "argument")) <> comma $$ 
-	sep [ptext (sLit "but its type") <+> quotes (pprType ty), 
-	     if n_args == 0 then ptext (sLit "has none") 
-	     else ptext (sLit "has only") <+> speakN n_args]
+        sep [ptext (sLit "but its type") <+> quotes (pprType ty), 
+             if n_args == 0 then ptext (sLit "has none") 
+             else ptext (sLit "has only") <+> speakN n_args]
 \end{code}
 
 Note [Foralls to left of arrow]
@@ -204,7 +198,7 @@ matchExpectedPArrTy exp_ty
 
 ----------------------
 matchExpectedTyConApp :: TyCon                -- T :: forall kv1 ... kvm. k1 -> ... -> kn -> *
-                      -> TcRhoType 	      -- orig_ty
+                      -> TcRhoType            -- orig_ty
                       -> TcM (TcCoercion,     -- T k1 k2 k3 a b c ~ orig_ty
                               [TcSigmaType])  -- Element types, k1 k2 k3 a b c
 
@@ -328,9 +322,9 @@ tcSubType origin ctxt ty_actual ty_expected
             ; return (coToHsWrapper cow <.> in_wrap) }
        ; return (sk_wrap <.> inst_wrap) }
 
-  | otherwise	-- Urgh!  It seems deeply weird to have equality
-    		-- when actual is not a polytype, and it makes a big 
-		-- difference e.g. tcfail104
+  | otherwise   -- Urgh!  It seems deeply weird to have equality
+                -- when actual is not a polytype, and it makes a big 
+                -- difference e.g. tcfail104
   = do { cow <- unify ty_actual ty_expected
        ; return (coToHsWrapper cow) }
   where
@@ -346,13 +340,13 @@ tcSubType origin ctxt ty_actual ty_expected
 tcInfer :: (TcType -> TcM a) -> TcM (a, TcType)
 tcInfer tc_infer = do { ty  <- newFlexiTyVarTy openTypeKind
                       ; res <- tc_infer ty
-		      ; return (res, ty) }
+                      ; return (res, ty) }
 
 -----------------
 tcWrapResult :: HsExpr TcId -> TcRhoType -> TcRhoType -> TcM (HsExpr TcId)
 tcWrapResult expr actual_ty res_ty
   = do { cow <- unifyType actual_ty res_ty
-       	        -- Both types are deeply skolemised
+                -- Both types are deeply skolemised
        ; return (mkHsWrapCo cow expr) }
 
 -----------------------------------
@@ -395,7 +389,7 @@ tcGen ctxt expected_ty thing_inside
                            text "expected_ty" <+> ppr expected_ty,
                            text "inst ty" <+> ppr tvs' <+> ppr rho' ]
 
-	-- Generally we must check that the "forall_tvs" havn't been constrained
+        -- Generally we must check that the "forall_tvs" havn't been constrained
         -- The interesting bit here is that we must include the free variables
         -- of the expected_ty.  Here's an example:
         --       runST (newVar True)
@@ -404,9 +398,9 @@ tcGen ctxt expected_ty thing_inside
         -- forall s'. ST s' a. That unifies s' with s, and a with MutVar s Bool.
         -- So now s' isn't unconstrained because it's linked to a.
         -- 
-	-- However [Oct 10] now that the untouchables are a range of 
+        -- However [Oct 10] now that the untouchables are a range of 
         -- TcTyVars, all this is handled automatically with no need for
-	-- extra faffing around
+        -- extra faffing around
 
         -- Use the *instantiated* type in the SkolemInfo
         -- so that the names of displayed type variables line up
@@ -416,14 +410,14 @@ tcGen ctxt expected_ty thing_inside
                                 thing_inside tvs' rho'
 
         ; return (wrap <.> mkWpLet ev_binds, result) }
-	  -- The ev_binds returned by checkConstraints is very
-	  -- often empty, in which case mkWpLet is a no-op
+          -- The ev_binds returned by checkConstraints is very
+          -- often empty, in which case mkWpLet is a no-op
 
 checkConstraints :: SkolemInfo
-		 -> [TcTyVar]		-- Skolems
-		 -> [EvVar]             -- Given
-		 -> TcM result
-		 -> TcM (TcEvBinds, result)
+                 -> [TcTyVar]           -- Skolems
+                 -> [EvVar]             -- Given
+                 -> TcM result
+                 -> TcM (TcEvBinds, result)
 
 checkConstraints skol_info skol_tvs given thing_inside
   | null skol_tvs && null given
@@ -435,7 +429,7 @@ checkConstraints skol_info skol_tvs given thing_inside
   = newImplication skol_info skol_tvs given thing_inside
 
 newImplication :: SkolemInfo -> [TcTyVar]
-	       -> [EvVar] -> TcM result
+               -> [EvVar] -> TcM result
                -> TcM (TcEvBinds, result)
 newImplication skol_info skol_tvs given thing_inside
   = ASSERT2( all isTcTyVar skol_tvs, ppr skol_tvs )
@@ -446,24 +440,24 @@ newImplication skol_info skol_tvs given thing_inside
                                       thing_inside
 
        ; if isEmptyWC wanted && no_equalities
-       	    -- Optimisation : if there are no wanteds, and the givens
-       	    -- are sufficiently simple, don't generate an implication
-       	    -- at all.  Reason for the hasEqualities test:
-	    -- we don't want to lose the "inaccessible alternative"
-	    -- error check
+            -- Optimisation : if there are no wanteds, and the givens
+            -- are sufficiently simple, don't generate an implication
+            -- at all.  Reason for the hasEqualities test:
+            -- we don't want to lose the "inaccessible alternative"
+            -- error check
          then 
             return (emptyTcEvBinds, result)
          else do
        { ev_binds_var <- newTcEvBinds
        ; env <- getLclEnv
        ; emitImplication $ Implic { ic_untch = untch
-             		     	  , ic_skols = skol_tvs
+                                  , ic_skols = skol_tvs
                                   , ic_fsks  = []
-                             	  , ic_given = given
+                                  , ic_given = given
                                   , ic_wanted = wanted
                                   , ic_insol  = insolubleWC wanted
                                   , ic_binds = ev_binds_var
-             		     	  , ic_env = env
+                                  , ic_env = env
                                   , ic_info = skol_info }
 
        ; return (TcEvBinds ev_binds_var, result) } }
@@ -515,7 +509,7 @@ unifyTypeList (ty1:tys@(ty2:_)) = do { _ <- unifyType ty1 ty2
 
 %************************************************************************
 %*                                                                      *
-                 uType and friends									
+                 uType and friends                                                                      
 %*                                                                      *
 %************************************************************************
 
@@ -569,11 +563,11 @@ uType origin orig_ty1 orig_ty2
        ; return co }
   where
     go :: TcType -> TcType -> TcM TcCoercion
-	-- The arguments to 'go' are always semantically identical 
-	-- to orig_ty{1,2} except for looking through type synonyms
+        -- The arguments to 'go' are always semantically identical 
+        -- to orig_ty{1,2} except for looking through type synonyms
 
         -- Variables; go for uVar
-	-- Note that we pass in *original* (before synonym expansion), 
+        -- Note that we pass in *original* (before synonym expansion), 
         -- so that type variables tend to get filled in with 
         -- the most informative version of the type
     go (TyVarTy tv1) ty2 
@@ -588,17 +582,17 @@ uType origin orig_ty1 orig_ty2
                Unfilled ds2 -> uUnfilledVar origin IsSwapped tv2 ds2 ty1 }
 
         -- See Note [Expanding synonyms during unification]
-	--
-	-- Also NB that we recurse to 'go' so that we don't push a
-	-- new item on the origin stack. As a result if we have
-	--   type Foo = Int
-	-- and we try to unify  Foo ~ Bool
-	-- we'll end up saying "can't match Foo with Bool"
-	-- rather than "can't match "Int with Bool".  See Trac #4535.
+        --
+        -- Also NB that we recurse to 'go' so that we don't push a
+        -- new item on the origin stack. As a result if we have
+        --   type Foo = Int
+        -- and we try to unify  Foo ~ Bool
+        -- we'll end up saying "can't match Foo with Bool"
+        -- rather than "can't match "Int with Bool".  See Trac #4535.
     go ty1 ty2
       | Just ty1' <- tcView ty1 = go ty1' ty2
       | Just ty2' <- tcView ty2 = go ty1  ty2'
-      	     
+             
         -- Functions (or predicate functions) just check the two parts
     go (FunTy fun1 arg1) (FunTy fun2 arg2)
       = do { co_l <- uType origin fun1 fun2
@@ -606,7 +600,7 @@ uType origin orig_ty1 orig_ty2
            ; return $ mkTcFunCo co_l co_r }
 
         -- Always defer if a type synonym family (type function)
-      	-- is involved.  (Data families behave rigidly.)
+        -- is involved.  (Data families behave rigidly.)
     go ty1@(TyConApp tc1 _) ty2
       | isSynFamilyTyCon tc1 = uType_defer origin ty1 ty2   
     go ty1 ty2@(TyConApp tc2 _)
@@ -622,7 +616,7 @@ uType origin orig_ty1 orig_ty2
       | m == n
       = return $ mkTcReflCo ty
 
-	-- See Note [Care with type applications]
+        -- See Note [Care with type applications]
         -- Do not decompose FunTy against App; 
         -- it's often a type error, so leave it for the constraint solver
     go (AppTy s1 t1) (AppTy s2 t2)
@@ -662,7 +656,7 @@ unifySigmaTy origin ty1 ty2
        ; let tys      = mkTyVarTys skol_tvs
              phi1     = Type.substTy subst1                   body1
              phi2     = Type.substTy (zipTopTvSubst tvs2 tys) body2
-	     skol_info = UnifyForAllSkol skol_tvs phi1
+             skol_info = UnifyForAllSkol skol_tvs phi1
 
        ; (ev_binds, co) <- checkConstraints skol_info skol_tvs [] $
                            uType origin phi1 phi2
@@ -694,7 +688,7 @@ Note [Mismatched type lists and application decomposition]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 When we find two TyConApps, you might think that the argument lists 
 are guaranteed equal length.  But they aren't. Consider matching
-	w (T x) ~ Foo (T x y)
+        w (T x) ~ Foo (T x y)
 We do match (w ~ Foo) first, but in some circumstances we simply create
 a deferred constraint; and then go ahead and match (T x ~ T x y).
 This came up in Trac #3950.
@@ -761,7 +755,7 @@ back into @uTys@ if it turns out that the variable is already bound.
 uUnfilledVar :: CtOrigin
              -> SwapFlag
              -> TcTyVar -> TcTyVarDetails       -- Tyvar 1
-             -> TcTauType  			-- Type 2
+             -> TcTauType                       -- Type 2
              -> TcM TcCoercion
 -- "Unfilled" means that the variable is definitely not a filled-in meta tyvar
 --            It might be a skolem, or untouchable, or meta
@@ -790,12 +784,12 @@ uUnfilledVar origin swapped tv1 details1 non_var_ty2  -- ty2 is not a type varia
                                   ; defer }
               }
 
-      _other -> do { traceTc "Skolem defer" (ppr tv1); defer }	-- Skolems of all sorts
+      _other -> do { traceTc "Skolem defer" (ppr tv1); defer }  -- Skolems of all sorts
   where
     defer = unSwap swapped (uType_defer origin) (mkTyVarTy tv1) non_var_ty2
                -- Occurs check or an untouchable: just defer
-	       -- NB: occurs check isn't necessarily fatal: 
-	       --     eg tv1 occured in type family parameter
+               -- NB: occurs check isn't necessarily fatal: 
+               --     eg tv1 occured in type family parameter
 
 ----------------
 uUnfilledVars :: CtOrigin
@@ -821,7 +815,7 @@ uUnfilledVars origin swapped tv1 details1 tv2 details2
            -- k2 < k1, so update tv1
            (GT, MetaTv { mtv_ref = ref1 }, _) -> updateMeta tv1 ref1 ty2
 
-	   -- k1 = k2, so we are free to update either way
+           -- k1 = k2, so we are free to update either way
            (EQ, MetaTv { mtv_info = i1, mtv_ref = ref1 }, 
                 MetaTv { mtv_info = i2, mtv_ref = ref2 })
                 | nicer_to_update_tv1 i1 i2 -> updateMeta tv1 ref1 ty2
@@ -829,8 +823,8 @@ uUnfilledVars origin swapped tv1 details1 tv2 details2
            (EQ, MetaTv { mtv_ref = ref1 }, _) -> updateMeta tv1 ref1 ty2
            (EQ, _, MetaTv { mtv_ref = ref2 }) -> updateMeta tv2 ref2 ty1
 
-	   -- Can't do it in-place, so defer
-	   -- This happens for skolems of all sorts
+           -- Can't do it in-place, so defer
+           -- This happens for skolems of all sorts
            (_, _, _) -> unSwap swapped (uType_defer origin) ty1 ty2 } }
   where
     k1  = tyVarKind tv1
@@ -1018,8 +1012,8 @@ sharing, so there's no great harm in losing it -- and it's generally
 more efficient to do the unification up-front.
 
 \begin{code}
-data LookupTyVarResult	-- The result of a lookupTcTyVar call
-  = Unfilled TcTyVarDetails	-- SkolemTv or virgin MetaTv
+data LookupTyVarResult  -- The result of a lookupTcTyVar call
+  = Unfilled TcTyVarDetails     -- SkolemTv or virgin MetaTv
   | Filled   TcType
 
 lookupTcTyVar :: TcTyVar -> TcM LookupTyVarResult
diff --git a/compiler/types/Class.lhs b/compiler/types/Class.lhs
index 3fb1bac..0a50497 100644
--- a/compiler/types/Class.lhs
+++ b/compiler/types/Class.lhs
@@ -6,33 +6,27 @@
 The @Class@ datatype
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module Class (
-	Class,
+        Class,
         ClassOpItem, DefMeth (..),
         ClassATItem,
         ClassMinimalDef,
-	defMethSpecOfDefMeth,
+        defMethSpecOfDefMeth,
 
-	FunDep,	pprFundeps, pprFunDep,
+        FunDep, pprFundeps, pprFunDep,
 
-	mkClass, classTyVars, classArity, 
-	classKey, className, classATs, classATItems, classTyCon, classMethods,
-	classOpItems, classBigSig, classExtraBigSig, classTvsFds, classSCTheta,
+        mkClass, classTyVars, classArity, 
+        classKey, className, classATs, classATItems, classTyCon, classMethods,
+        classOpItems, classBigSig, classExtraBigSig, classTvsFds, classSCTheta,
         classAllSelIds, classSCSelId, classMinimalDef
     ) where
 
 #include "Typeable.h"
 #include "HsVersions.h"
 
-import {-# SOURCE #-} TyCon	( TyCon, tyConName, tyConUnique )
-import {-# SOURCE #-} TypeRep	( PredType )
+import {-# SOURCE #-} TyCon     ( TyCon, tyConName, tyConUnique )
+import {-# SOURCE #-} TypeRep   ( PredType )
 import CoAxiom
 import Var
 import Name
@@ -48,9 +42,9 @@ import qualified Data.Data as Data
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[Class-basic]{@Class@: basic definition}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 A @Class@ corresponds to a Greek kappa in the static semantics:
@@ -58,46 +52,46 @@ A @Class@ corresponds to a Greek kappa in the static semantics:
 \begin{code}
 data Class
   = Class {
-	classTyCon :: TyCon,	-- The data type constructor for
-				-- dictionaries of this class
+        classTyCon :: TyCon,    -- The data type constructor for
+                                -- dictionaries of this class
                                 -- See Note [ATyCon for classes] in TypeRep
 
-	className :: Name,              -- Just the cached name of the TyCon
-	classKey  :: Unique,		-- Cached unique of TyCon
-	
-	classTyVars  :: [TyVar],	-- The class kind and type variables;
-		     			-- identical to those of the TyCon
+        className :: Name,              -- Just the cached name of the TyCon
+        classKey  :: Unique,            -- Cached unique of TyCon
+        
+        classTyVars  :: [TyVar],        -- The class kind and type variables;
+                                        -- identical to those of the TyCon
 
-	classFunDeps :: [FunDep TyVar],	-- The functional dependencies
+        classFunDeps :: [FunDep TyVar], -- The functional dependencies
 
-	-- Superclasses: eg: (F a ~ b, F b ~ G a, Eq a, Show b)
+        -- Superclasses: eg: (F a ~ b, F b ~ G a, Eq a, Show b)
         -- We need value-level selectors for both the dictionary 
-	-- superclasses and the equality superclasses
-	classSCTheta :: [PredType],	-- Immediate superclasses, 
-	classSCSels  :: [Id],		-- Selector functions to extract the
-		     			--   superclasses from a 
-					--   dictionary of this class
-	-- Associated types
-        classATStuff :: [ClassATItem],	-- Associated type families
+        -- superclasses and the equality superclasses
+        classSCTheta :: [PredType],     -- Immediate superclasses, 
+        classSCSels  :: [Id],           -- Selector functions to extract the
+                                        --   superclasses from a 
+                                        --   dictionary of this class
+        -- Associated types
+        classATStuff :: [ClassATItem],  -- Associated type families
 
         -- Class operations (methods, not superclasses)
-	classOpStuff :: [ClassOpItem],	-- Ordered by tag
+        classOpStuff :: [ClassOpItem],  -- Ordered by tag
 
-	-- Minimal complete definition
-	classMinimalDef :: ClassMinimalDef
+        -- Minimal complete definition
+        classMinimalDef :: ClassMinimalDef
      }
   deriving Typeable
 
 type FunDep a = ([a],[a])  --  e.g. class C a b c | a b -> c, a c -> b where...
-			   --  Here fun-deps are [([a,b],[c]), ([a,c],[b])]
+                           --  Here fun-deps are [([a,b],[c]), ([a,c],[b])]
 
 type ClassOpItem = (Id, DefMeth)
         -- Selector function; contains unfolding
-	-- Default-method info
+        -- Default-method info
 
-data DefMeth = NoDefMeth 		-- No default method
-	     | DefMeth Name  		-- A polymorphic default method
-	     | GenDefMeth Name 		-- A generic default method
+data DefMeth = NoDefMeth                -- No default method
+             | DefMeth Name             -- A polymorphic default method
+             | GenDefMeth Name          -- A generic default method
              deriving Eq
 
 type ClassATItem = (TyCon,           -- See Note [Associated type tyvar names]
@@ -112,9 +106,9 @@ type ClassMinimalDef = BooleanFormula Name -- Required methods
 defMethSpecOfDefMeth :: DefMeth -> DefMethSpec
 defMethSpecOfDefMeth meth
  = case meth of
-	NoDefMeth	-> NoDM
-	DefMeth _	-> VanillaDM
-	GenDefMeth _	-> GenericDM
+        NoDefMeth       -> NoDM
+        DefMeth _       -> VanillaDM
+        GenDefMeth _    -> GenericDM
 
 \end{code}
 
@@ -164,9 +158,9 @@ Having the same variables for class and tycon is also used in checkValidRoles
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[Class-selectors]{@Class@: simple selectors}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 The rest of these functions are just simple selectors.
@@ -174,7 +168,7 @@ The rest of these functions are just simple selectors.
 \begin{code}
 classArity :: Class -> Arity
 classArity clas = length (classTyVars clas)
-	-- Could memoise this
+        -- Could memoise this
 
 classAllSelIds :: Class -> [Id]
 -- Both superclass-dictionary and method selectors
@@ -209,21 +203,21 @@ classTvsFds c
 
 classBigSig :: Class -> ([TyVar], [PredType], [Id], [ClassOpItem])
 classBigSig (Class {classTyVars = tyvars, classSCTheta = sc_theta, 
-	 	    classSCSels = sc_sels, classOpStuff = op_stuff})
+                    classSCSels = sc_sels, classOpStuff = op_stuff})
   = (tyvars, sc_theta, sc_sels, op_stuff)
 
 classExtraBigSig :: Class -> ([TyVar], [FunDep TyVar], [PredType], [Id], [ClassATItem], [ClassOpItem])
 classExtraBigSig (Class {classTyVars = tyvars, classFunDeps = fundeps,
-			 classSCTheta = sc_theta, classSCSels = sc_sels,
-			 classATStuff = ats, classOpStuff = op_stuff})
+                         classSCTheta = sc_theta, classSCSels = sc_sels,
+                         classATStuff = ats, classOpStuff = op_stuff})
   = (tyvars, fundeps, sc_theta, sc_sels, ats, op_stuff)
 \end{code}
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[Class-instances]{Instance declarations for @Class@}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 We compare @Classes@ by their keys (which include @Uniques@).
